from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.domain import domain_common_types_pb2 as _domain_common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DomainIdReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["domain_history_id", "domain_id"]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        domain_id: _domain_common_types_pb2.DomainId
        def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["domain_does_not_exist"]
        class DomainDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: DomainIdReply.Exception.DomainDoesNotExist
        def __init__(self, domain_does_not_exist: _Optional[_Union[DomainIdReply.Exception.DomainDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainIdReply.Data
    exception: DomainIdReply.Exception
    def __init__(self, data: _Optional[_Union[DomainIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainIdReply.Exception, _Mapping]] = ...) -> None: ...

class DomainIdRequest(_message.Message):
    __slots__ = ["fqdn"]
    FQDN_FIELD_NUMBER: _ClassVar[int]
    fqdn: _domain_common_types_pb2.Fqdn
    def __init__(self, fqdn: _Optional[_Union[_domain_common_types_pb2.Fqdn, _Mapping]] = ...) -> None: ...

class DomainInfoReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["administrative_contacts", "administrative_contacts_old", "auth_info", "delete_candidate_at", "delete_candidate_scheduled_at", "delete_warning_scheduled_at", "domain_history_id", "domain_id", "events", "expiration_warning_scheduled_at", "expires_at", "fqdn", "keyset", "keyset_old", "nsset", "nsset_old", "outzone_at", "outzone_scheduled_at", "outzone_unguarded_warning_scheduled_at", "registrant", "registrant_old", "sponsoring_registrar", "validation_expires_at"]
        ADMINISTRATIVE_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        ADMINISTRATIVE_CONTACTS_OLD_FIELD_NUMBER: _ClassVar[int]
        AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
        DELETE_CANDIDATE_AT_FIELD_NUMBER: _ClassVar[int]
        DELETE_CANDIDATE_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        DELETE_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        EXPIRATION_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        EXPIRES_AT_FIELD_NUMBER: _ClassVar[int]
        FQDN_FIELD_NUMBER: _ClassVar[int]
        KEYSET_FIELD_NUMBER: _ClassVar[int]
        KEYSET_OLD_FIELD_NUMBER: _ClassVar[int]
        NSSET_FIELD_NUMBER: _ClassVar[int]
        NSSET_OLD_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_AT_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        OUTZONE_UNGUARDED_WARNING_SCHEDULED_AT_FIELD_NUMBER: _ClassVar[int]
        REGISTRANT_FIELD_NUMBER: _ClassVar[int]
        REGISTRANT_OLD_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        VALIDATION_EXPIRES_AT_FIELD_NUMBER: _ClassVar[int]
        administrative_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactRef]
        administrative_contacts_old: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        auth_info: _common_types_pb2.AuthInfo
        delete_candidate_at: _timestamp_pb2.Timestamp
        delete_candidate_scheduled_at: _timestamp_pb2.Timestamp
        delete_warning_scheduled_at: _timestamp_pb2.Timestamp
        domain_history_id: _domain_common_types_pb2.DomainHistoryId
        domain_id: _domain_common_types_pb2.DomainId
        events: _object_events_pb2.ObjectEvents
        expiration_warning_scheduled_at: _timestamp_pb2.Timestamp
        expires_at: _timestamp_pb2.Timestamp
        fqdn: _domain_common_types_pb2.Fqdn
        keyset: _keyset_common_types_pb2.KeysetRef
        keyset_old: _keyset_common_types_pb2.KeysetId
        nsset: _nsset_common_types_pb2.NssetRef
        nsset_old: _nsset_common_types_pb2.NssetId
        outzone_at: _timestamp_pb2.Timestamp
        outzone_scheduled_at: _timestamp_pb2.Timestamp
        outzone_unguarded_warning_scheduled_at: _timestamp_pb2.Timestamp
        registrant: _contact_common_types_pb2.ContactRef
        registrant_old: _contact_common_types_pb2.ContactId
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        validation_expires_at: _timestamp_pb2.Timestamp
        def __init__(self, fqdn: _Optional[_Union[_domain_common_types_pb2.Fqdn, _Mapping]] = ..., domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ..., nsset_old: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., nsset: _Optional[_Union[_nsset_common_types_pb2.NssetRef, _Mapping]] = ..., keyset_old: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset: _Optional[_Union[_keyset_common_types_pb2.KeysetRef, _Mapping]] = ..., registrant_old: _Optional[_Union[_contact_common_types_pb2.ContactId, _Mapping]] = ..., registrant: _Optional[_Union[_contact_common_types_pb2.ContactRef, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ..., administrative_contacts_old: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., administrative_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactRef, _Mapping]]] = ..., expires_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., auth_info: _Optional[_Union[_common_types_pb2.AuthInfo, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., expiration_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_unguarded_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_warning_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_candidate_scheduled_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., validation_expires_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., outzone_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., delete_candidate_at: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["domain_does_not_exist"]
        class DomainDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        DOMAIN_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        domain_does_not_exist: DomainInfoReply.Exception.DomainDoesNotExist
        def __init__(self, domain_does_not_exist: _Optional[_Union[DomainInfoReply.Exception.DomainDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: DomainInfoReply.Data
    exception: DomainInfoReply.Exception
    def __init__(self, data: _Optional[_Union[DomainInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[DomainInfoReply.Exception, _Mapping]] = ...) -> None: ...

class DomainInfoRequest(_message.Message):
    __slots__ = ["domain_history_id", "domain_id"]
    DOMAIN_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    DOMAIN_ID_FIELD_NUMBER: _ClassVar[int]
    domain_history_id: _domain_common_types_pb2.DomainHistoryId
    domain_id: _domain_common_types_pb2.DomainId
    def __init__(self, domain_id: _Optional[_Union[_domain_common_types_pb2.DomainId, _Mapping]] = ..., domain_history_id: _Optional[_Union[_domain_common_types_pb2.DomainHistoryId, _Mapping]] = ...) -> None: ...
