from fred_api.registry.contact import contact_common_types_pb2 as _contact_common_types_pb2
from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from fred_api.registry import common_types_pb2 as _common_types_pb2
from fred_api.registry import object_events_pb2 as _object_events_pb2
from fred_api.registry.registrar import registrar_common_types_pb2 as _registrar_common_types_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class DnsKey(_message.Message):
    __slots__ = ["alg", "flags", "key", "protocol"]
    ALG_FIELD_NUMBER: _ClassVar[int]
    FLAGS_FIELD_NUMBER: _ClassVar[int]
    KEY_FIELD_NUMBER: _ClassVar[int]
    PROTOCOL_FIELD_NUMBER: _ClassVar[int]
    alg: int
    flags: int
    key: str
    protocol: int
    def __init__(self, flags: _Optional[int] = ..., protocol: _Optional[int] = ..., alg: _Optional[int] = ..., key: _Optional[str] = ...) -> None: ...

class KeysetIdReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["keyset_history_id", "keyset_id"]
        KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
        keyset_id: _keyset_common_types_pb2.KeysetId
        def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["keyset_does_not_exist"]
        class KeysetDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: KeysetIdReply.Exception.KeysetDoesNotExist
        def __init__(self, keyset_does_not_exist: _Optional[_Union[KeysetIdReply.Exception.KeysetDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetIdReply.Data
    exception: KeysetIdReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetIdReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetIdReply.Exception, _Mapping]] = ...) -> None: ...

class KeysetIdRequest(_message.Message):
    __slots__ = ["keyset_handle"]
    KEYSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
    keyset_handle: _keyset_common_types_pb2.KeysetHandle
    def __init__(self, keyset_handle: _Optional[_Union[_keyset_common_types_pb2.KeysetHandle, _Mapping]] = ...) -> None: ...

class KeysetInfoReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["auth_info", "dns_keys", "events", "keyset_handle", "keyset_history_id", "keyset_id", "sponsoring_registrar", "technical_contacts", "technical_contacts_old"]
        AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
        DNS_KEYS_FIELD_NUMBER: _ClassVar[int]
        EVENTS_FIELD_NUMBER: _ClassVar[int]
        KEYSET_HANDLE_FIELD_NUMBER: _ClassVar[int]
        KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        SPONSORING_REGISTRAR_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_FIELD_NUMBER: _ClassVar[int]
        TECHNICAL_CONTACTS_OLD_FIELD_NUMBER: _ClassVar[int]
        auth_info: _common_types_pb2.AuthInfo
        dns_keys: _containers.RepeatedCompositeFieldContainer[DnsKey]
        events: _object_events_pb2.ObjectEvents
        keyset_handle: _keyset_common_types_pb2.KeysetHandle
        keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
        keyset_id: _keyset_common_types_pb2.KeysetId
        sponsoring_registrar: _registrar_common_types_pb2.RegistrarHandle
        technical_contacts: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactRef]
        technical_contacts_old: _containers.RepeatedCompositeFieldContainer[_contact_common_types_pb2.ContactId]
        def __init__(self, keyset_handle: _Optional[_Union[_keyset_common_types_pb2.KeysetHandle, _Mapping]] = ..., keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ..., dns_keys: _Optional[_Iterable[_Union[DnsKey, _Mapping]]] = ..., technical_contacts_old: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactId, _Mapping]]] = ..., technical_contacts: _Optional[_Iterable[_Union[_contact_common_types_pb2.ContactRef, _Mapping]]] = ..., auth_info: _Optional[_Union[_common_types_pb2.AuthInfo, _Mapping]] = ..., events: _Optional[_Union[_object_events_pb2.ObjectEvents, _Mapping]] = ..., sponsoring_registrar: _Optional[_Union[_registrar_common_types_pb2.RegistrarHandle, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["keyset_does_not_exist"]
        class KeysetDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        keyset_does_not_exist: KeysetInfoReply.Exception.KeysetDoesNotExist
        def __init__(self, keyset_does_not_exist: _Optional[_Union[KeysetInfoReply.Exception.KeysetDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetInfoReply.Data
    exception: KeysetInfoReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetInfoReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetInfoReply.Exception, _Mapping]] = ...) -> None: ...

class KeysetInfoRequest(_message.Message):
    __slots__ = ["keyset_history_id", "keyset_id"]
    KEYSET_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    keyset_history_id: _keyset_common_types_pb2.KeysetHistoryId
    keyset_id: _keyset_common_types_pb2.KeysetId
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., keyset_history_id: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryId, _Mapping]] = ...) -> None: ...
