from fred_api.registry.keyset import keyset_common_types_pb2 as _keyset_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class KeysetStateHistory(_message.Message):
    __slots__ = ["timeline", "valid_to"]
    class Record(_message.Message):
        __slots__ = ["flags", "valid_from"]
        class FlagsEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        FLAGS_FIELD_NUMBER: _ClassVar[int]
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        flags: _containers.ScalarMap[str, bool]
        valid_from: _timestamp_pb2.Timestamp
        def __init__(self, valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...
    TIMELINE_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    timeline: _containers.RepeatedCompositeFieldContainer[KeysetStateHistory.Record]
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, timeline: _Optional[_Iterable[_Union[KeysetStateHistory.Record, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class KeysetStateHistoryReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["history", "keyset_id"]
        HISTORY_FIELD_NUMBER: _ClassVar[int]
        KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
        history: KeysetStateHistory
        keyset_id: _keyset_common_types_pb2.KeysetId
        def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., history: _Optional[_Union[KeysetStateHistory, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["invalid_history_interval", "keyset_does_not_exist"]
        class InvalidHistoryInterval(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class KeysetDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        KEYSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        invalid_history_interval: KeysetStateHistoryReply.Exception.InvalidHistoryInterval
        keyset_does_not_exist: KeysetStateHistoryReply.Exception.KeysetDoesNotExist
        def __init__(self, keyset_does_not_exist: _Optional[_Union[KeysetStateHistoryReply.Exception.KeysetDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[KeysetStateHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: KeysetStateHistoryReply.Data
    exception: KeysetStateHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[KeysetStateHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[KeysetStateHistoryReply.Exception, _Mapping]] = ...) -> None: ...

class KeysetStateHistoryRequest(_message.Message):
    __slots__ = ["history", "keyset_id"]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    KEYSET_ID_FIELD_NUMBER: _ClassVar[int]
    history: _keyset_common_types_pb2.KeysetHistoryInterval
    keyset_id: _keyset_common_types_pb2.KeysetId
    def __init__(self, keyset_id: _Optional[_Union[_keyset_common_types_pb2.KeysetId, _Mapping]] = ..., history: _Optional[_Union[_keyset_common_types_pb2.KeysetHistoryInterval, _Mapping]] = ...) -> None: ...
