from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class NssetStateHistory(_message.Message):
    __slots__ = ["timeline", "valid_to"]
    class Record(_message.Message):
        __slots__ = ["flags", "valid_from"]
        class FlagsEntry(_message.Message):
            __slots__ = ["key", "value"]
            KEY_FIELD_NUMBER: _ClassVar[int]
            VALUE_FIELD_NUMBER: _ClassVar[int]
            key: str
            value: bool
            def __init__(self, key: _Optional[str] = ..., value: bool = ...) -> None: ...
        FLAGS_FIELD_NUMBER: _ClassVar[int]
        VALID_FROM_FIELD_NUMBER: _ClassVar[int]
        flags: _containers.ScalarMap[str, bool]
        valid_from: _timestamp_pb2.Timestamp
        def __init__(self, valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., flags: _Optional[_Mapping[str, bool]] = ...) -> None: ...
    TIMELINE_FIELD_NUMBER: _ClassVar[int]
    VALID_TO_FIELD_NUMBER: _ClassVar[int]
    timeline: _containers.RepeatedCompositeFieldContainer[NssetStateHistory.Record]
    valid_to: _timestamp_pb2.Timestamp
    def __init__(self, timeline: _Optional[_Iterable[_Union[NssetStateHistory.Record, _Mapping]]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ...) -> None: ...

class NssetStateHistoryReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["history", "nsset_id"]
        HISTORY_FIELD_NUMBER: _ClassVar[int]
        NSSET_ID_FIELD_NUMBER: _ClassVar[int]
        history: NssetStateHistory
        nsset_id: _nsset_common_types_pb2.NssetId
        def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., history: _Optional[_Union[NssetStateHistory, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["invalid_history_interval", "nsset_does_not_exist"]
        class InvalidHistoryInterval(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        class NssetDoesNotExist(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        INVALID_HISTORY_INTERVAL_FIELD_NUMBER: _ClassVar[int]
        NSSET_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        invalid_history_interval: NssetStateHistoryReply.Exception.InvalidHistoryInterval
        nsset_does_not_exist: NssetStateHistoryReply.Exception.NssetDoesNotExist
        def __init__(self, nsset_does_not_exist: _Optional[_Union[NssetStateHistoryReply.Exception.NssetDoesNotExist, _Mapping]] = ..., invalid_history_interval: _Optional[_Union[NssetStateHistoryReply.Exception.InvalidHistoryInterval, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: NssetStateHistoryReply.Data
    exception: NssetStateHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[NssetStateHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[NssetStateHistoryReply.Exception, _Mapping]] = ...) -> None: ...

class NssetStateHistoryRequest(_message.Message):
    __slots__ = ["history", "nsset_id"]
    HISTORY_FIELD_NUMBER: _ClassVar[int]
    NSSET_ID_FIELD_NUMBER: _ClassVar[int]
    history: _nsset_common_types_pb2.NssetHistoryInterval
    nsset_id: _nsset_common_types_pb2.NssetId
    def __init__(self, nsset_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., history: _Optional[_Union[_nsset_common_types_pb2.NssetHistoryInterval, _Mapping]] = ...) -> None: ...
