from fred_api.registry.nsset import nsset_common_types_pb2 as _nsset_common_types_pb2
from google.protobuf import timestamp_pb2 as _timestamp_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class SearchNssetHistoryReply(_message.Message):
    __slots__ = ["data", "exception"]
    class Data(_message.Message):
        __slots__ = ["estimated_total", "results", "searched_items"]
        class FuzzyValue(_message.Message):
            __slots__ = ["lower_estimate", "upper_estimate"]
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        class Result(_message.Message):
            __slots__ = ["histories", "object_id"]
            class HistoryPeriod(_message.Message):
                __slots__ = ["matched_items", "nsset_history_ids", "valid_from", "valid_to"]
                MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
                NSSET_HISTORY_IDS_FIELD_NUMBER: _ClassVar[int]
                VALID_FROM_FIELD_NUMBER: _ClassVar[int]
                VALID_TO_FIELD_NUMBER: _ClassVar[int]
                matched_items: _containers.RepeatedScalarFieldContainer[str]
                nsset_history_ids: _containers.RepeatedCompositeFieldContainer[_nsset_common_types_pb2.NssetHistoryId]
                valid_from: _timestamp_pb2.Timestamp
                valid_to: _timestamp_pb2.Timestamp
                def __init__(self, matched_items: _Optional[_Iterable[str]] = ..., valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., nsset_history_ids: _Optional[_Iterable[_Union[_nsset_common_types_pb2.NssetHistoryId, _Mapping]]] = ...) -> None: ...
            HISTORIES_FIELD_NUMBER: _ClassVar[int]
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            histories: _containers.RepeatedCompositeFieldContainer[SearchNssetHistoryReply.Data.Result.HistoryPeriod]
            object_id: _nsset_common_types_pb2.NssetId
            def __init__(self, object_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., histories: _Optional[_Iterable[_Union[SearchNssetHistoryReply.Data.Result.HistoryPeriod, _Mapping]]] = ...) -> None: ...
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        estimated_total: SearchNssetHistoryReply.Data.FuzzyValue
        results: _containers.RepeatedCompositeFieldContainer[SearchNssetHistoryReply.Data.Result]
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchNssetHistoryReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchNssetHistoryReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ["chronology_violation"]
        class ChronologyViolation(_message.Message):
            __slots__ = []
            def __init__(self) -> None: ...
        CHRONOLOGY_VIOLATION_FIELD_NUMBER: _ClassVar[int]
        chronology_violation: SearchNssetHistoryReply.Exception.ChronologyViolation
        def __init__(self, chronology_violation: _Optional[_Union[SearchNssetHistoryReply.Exception.ChronologyViolation, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: SearchNssetHistoryReply.Data
    exception: SearchNssetHistoryReply.Exception
    def __init__(self, data: _Optional[_Union[SearchNssetHistoryReply.Data, _Mapping]] = ..., exception: _Optional[_Union[SearchNssetHistoryReply.Exception, _Mapping]] = ...) -> None: ...

class SearchNssetHistoryRequest(_message.Message):
    __slots__ = ["data_valid_from", "data_valid_to", "max_number_of_nssets", "query_values", "searched_items"]
    DATA_VALID_FROM_FIELD_NUMBER: _ClassVar[int]
    DATA_VALID_TO_FIELD_NUMBER: _ClassVar[int]
    MAX_NUMBER_OF_NSSETS_FIELD_NUMBER: _ClassVar[int]
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    data_valid_from: _timestamp_pb2.Timestamp
    data_valid_to: _timestamp_pb2.Timestamp
    max_number_of_nssets: int
    query_values: _containers.RepeatedScalarFieldContainer[str]
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., max_number_of_nssets: _Optional[int] = ..., data_valid_from: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., data_valid_to: _Optional[_Union[_timestamp_pb2.Timestamp, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...

class SearchNssetReply(_message.Message):
    __slots__ = ["data"]
    class Data(_message.Message):
        __slots__ = ["estimated_total", "results", "searched_items"]
        class FuzzyValue(_message.Message):
            __slots__ = ["lower_estimate", "upper_estimate"]
            LOWER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            UPPER_ESTIMATE_FIELD_NUMBER: _ClassVar[int]
            lower_estimate: int
            upper_estimate: int
            def __init__(self, lower_estimate: _Optional[int] = ..., upper_estimate: _Optional[int] = ...) -> None: ...
        class Result(_message.Message):
            __slots__ = ["matched_items", "object_id"]
            MATCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
            OBJECT_ID_FIELD_NUMBER: _ClassVar[int]
            matched_items: _containers.RepeatedScalarFieldContainer[str]
            object_id: _nsset_common_types_pb2.NssetId
            def __init__(self, object_id: _Optional[_Union[_nsset_common_types_pb2.NssetId, _Mapping]] = ..., matched_items: _Optional[_Iterable[str]] = ...) -> None: ...
        ESTIMATED_TOTAL_FIELD_NUMBER: _ClassVar[int]
        RESULTS_FIELD_NUMBER: _ClassVar[int]
        SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
        estimated_total: SearchNssetReply.Data.FuzzyValue
        results: _containers.RepeatedCompositeFieldContainer[SearchNssetReply.Data.Result]
        searched_items: _containers.RepeatedScalarFieldContainer[str]
        def __init__(self, results: _Optional[_Iterable[_Union[SearchNssetReply.Data.Result, _Mapping]]] = ..., estimated_total: _Optional[_Union[SearchNssetReply.Data.FuzzyValue, _Mapping]] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    data: SearchNssetReply.Data
    def __init__(self, data: _Optional[_Union[SearchNssetReply.Data, _Mapping]] = ...) -> None: ...

class SearchNssetRequest(_message.Message):
    __slots__ = ["limit", "query_values", "searched_items"]
    LIMIT_FIELD_NUMBER: _ClassVar[int]
    QUERY_VALUES_FIELD_NUMBER: _ClassVar[int]
    SEARCHED_ITEMS_FIELD_NUMBER: _ClassVar[int]
    limit: int
    query_values: _containers.RepeatedScalarFieldContainer[str]
    searched_items: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, query_values: _Optional[_Iterable[str]] = ..., limit: _Optional[int] = ..., searched_items: _Optional[_Iterable[str]] = ...) -> None: ...
